package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleExpansionNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleExpansionNode extends ISLScheduleNode  {
	
	/* @generated */
	protected ISLScheduleExpansionNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleExpansionNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLScheduleExpansionNode build(long ptr) {
		return new ISLScheduleExpansionNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLScheduleExpansionNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_expansion_get_expansion 
	 * 
	 * @generated
	**/
	public ISLUnionMap getExpansion() {
		/*** PROTECTED REGION ID(isl_schedule_node_expansion_get_expansion) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_node_expansion_get_expansion(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_node_expansion_get_contraction 
	 * 
	 * @generated
	**/
	public ISLUnionPWMultiAff getContraction() {
		/*** PROTECTED REGION ID(isl_schedule_node_expansion_get_contraction) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_schedule_node_expansion_get_contraction(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleExpansionNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleExpansionNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
